> For the complete documentation index, see [llms.txt](https://docs.apryse.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.apryse.com/android/changelogs/version-7/v7-0-4.md).

# Version 7.0.4 Changelog (November 26, 2019)

World's #1 PDF SDK Library for Web, Mobile, Server, Desktop

Version: 7.0.4.73249

Release Date: November 26, 2019

## New features

* Collaboration APIs have been improved to help with faster integration process, see guide: [Connect with server](/android/collaboration/server-a.md)
* New magnifying glasses appearance

![](https://226546913-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2F0QItsdFBmuuL9ezHimHy%2Fuploads%2Fgit-blob-d48967e2373e228a3390be1fb523ccdf7fcf8a79%2Fa50ddc5c622107a5e91a4ccafdf67469b874dd1f-378x256.png?alt=media)

* New APIs for import/export user bookmarks, see guide: [User bookmarks](/android/bookmarks/user-bookmarks-a.md#import-and-export)
* Stability and usability improvements for [`FreehandCreate`](https://sdk.apryse.com/api/android/javadoc/reference/com/pdftron/pdf/tools/FreehandCreate.html) tool

## Fixed

* Fixed issue where when sharing documents in the collaboration viewer, not all annotations are included
* Fixed issue where download dialog is missing for non-PDF remote links
* Fixed issue where [`CustomRelativeLayout`](https://sdk.apryse.com/api/android/javadoc/reference/com/pdftron/pdf/tools/CustomRelativeLayout.html) does not exactly match annotation bounding box, as well as issue where the location is incorrect after a fling
* Fixed issue where rich text would crash on API 19, rich text will now be a feature available on API 21+
* Fixed issue where some annotations would appear to be rotated upon selection when viewer is rotated
* Fixed issue where EditText would not show on some corrupted text fields
* Fixed issue where thumbnail slider is hidden on API 19 in full screen mode
* Fixed potential OOM crash when open and close the [`ThumbnailsViewFragment`](https://sdk.apryse.com/api/android/javadoc/reference/com/pdftron/pdf/controls/ThumbnailsViewFragment.html) many times in the same session

## APIs

### PDFViewCtrlTools package

#### FreehandCreate

*new* method: `void setFromEditToolbar(boolean)`

#### UndoRedoManager

*new* method: `boolean canInkUndo()`

*new* method: `void takeInitialInkSnapshot()`

*new* method: `void undoToPreviousInitialInk()`

#### BookmarkManager

*new* static method: `String exportPdfBookmarks(PDFDoc)`

*new* static method: `String exportUserBookmarks(Context, String)`

*new* static method: `ArrayList<UserBookmarkItem> fromJSON(String)`

*new* static method: `List<UserBookmarkItem> getPdfBookmarks(PDFDoc)`

*new* static method: `void importPdfBookmarks(PDFViewCtrl, String)`

*new* static method: `void importUserBookmarks(Context, String, String)`

*new* static method: `String toJSON(List<UserBookmarkItem>)`

#### PdfViewCtrlSettingsManager

*new* static method: `boolean getFollowSystemDarkMode(Context)`

*new* static method: `void setFollowSystemDarkMode(Context, boolean)`

#### Utils

*new* static method: `void closeDocQuietly(PDFViewCtrl)`

#### SelectionLoupe

*new* constructor: `SelectionLoupe(PDFViewCtrl)`

*new* method: `void dismiss()`

*new* method: `void setup(Bitmap)`

*new* method: `void show()`

*new* method: `void show(float, float)`

*removed* constructor: `SelectionLoupe(Context)`

*removed* constructor: `SelectionLoupe(Context, AttributeSet)`

*removed* constructor: `SelectionLoupe(Context, AttributeSet, int)`

*removed* method: `void setup(Bitmap, float)`

*modified* class: `SelectionLoupe`

|       | Declaration                                      |
| ----- | ------------------------------------------------ |
| From: | public class SelectionLoupe extends LinearLayout |
| To:   | public class SelectionLoupe extends CardView     |

### pdftron-collab package

#### DataRepository

*removed* method: `void close()`

#### UserDao

*new* method: `void updateIsCurrentUser(String, boolean)`

#### UserEntity

*new* method: `boolean isCurrentUser()`

*new* method: `void setIsCurrentUser(boolean)`

#### User

*new* method: `boolean isCurrentUser()`

#### CustomService

*new* method: `void importAnnotationCommand(CollabDatabase, String, String, boolean)`

*new* method: `void importAnnotations(CollabDatabase, String, String, boolean)`

*new* method: `void setCurrentUser(CollabDatabase, String, String)`

#### CustomServiceUtils

*new* static method: `void addLastXfdf(CollabDatabase, String)`

*new* static method: `void importAnnotationCommand(CollabDatabase, String, String, boolean)`

*new* static method: `void importAnnotations(CollabDatabase, String, String, boolean)`

*new* static method: `void setCurrentUser(CollabDatabase, String, String)`

*modified* static method: `void addAnnotations(CollabDatabase, HashMap<String, AnnotationEntity>)`

|       | Declaration                                                                             |
| ----- | --------------------------------------------------------------------------------------- |
| From: | public static void addAnnotations(CollabDatabase, HashMap\<String, AnnotationEntity>)   |
| To:   | public static String addAnnotations(CollabDatabase, HashMap\<String, AnnotationEntity>) |

#### CollabManager

*new* class: `CollabManager`

*new* method: `void addAnnotation(AnnotationEntity)`

*new* method: `void addAnnotations(HashMap<String, AnnotationEntity>)`

*new* method: `void addUser(String, String)`

*new* method: `void cleanup()`

*new* method: `void deleteAnnotation(String)`

*new* method: `DocumentViewModel getViewModel()`

*new* method: `void importAnnotationCommand(String)`

*new* method: `void importAnnotationCommand(String, boolean)`

*new* method: `void importAnnotations(String, boolean)`

*new* method: `void modifyAnnotation(AnnotationEntity)`

*new* method: `void sendAnnotation(String, ArrayList<AnnotationEntity>, String, String)`

*new* method: `void setCollabManagerListener(CollabManagerListener)`

*new* method: `void setCurrentDocument(DocumentEntity)`

*new* method: `void setCurrentDocument(String)`

*new* method: `void setCurrentUser(String, String)`

*new* method: `void setCustomConnection(CustomService)`

#### CollabManager.CollabManagerListener

*new* interface: `CollabManagerListener`

*new* method: `void onSendAnnotation(String, ArrayList<AnnotationEntity>, String, String)`

#### CollabViewerTabFragment

*new* method: `void handleOnlineShare()`

#### CollabViewerTabHostFragment

*new* method: `CollabManager getCollabManager()`

#### JsonUtils

*removed* static method: `boolean isValidInsertEntity(AnnotationEntity)`

#### XfdfUtils

*new* static method: `void fillAnnotationEntity(String, AnnotationEntity)`

*new* static method: `boolean isValidInsertEntity(AnnotationEntity)`

*new* static method: `HashMap<String, AnnotationEntity> parseXfdf(String, String)`

*new* static method: `HashMap<String, AnnotationEntity> parseXfdfCommand(String, String)`

*new* static method: `AnnotationEntity toAnnotationEntity(PDFDoc, String, Annot)`

*new* static method: `AnnotationEntity xfdfToAnnotationEntity(String, JSONObject)`

*removed* static method: `void fillAnnotationEntity(AnnotationEntity)`

*removed* static method: `HashMap<String, Object> parseXfdf(String)`

*removed* static method: `AnnotationEntity toAnnotationEntity(PDFDoc, Annot)`

*removed* static method: `AnnotationEntity xfdfToAnnotationEntity(JSONObject)`

### pdftron-collab-wvs package

#### BlackBoxConnection

*new* constructor: `BlackBoxConnection()`

*new* method: `void onSendAnnotation(String, ArrayList<AnnotationEntity>, String, String)`

*new* method: `void setCollabManager(CollabManager)`

*removed* constructor: `BlackBoxConnection(Context)`

*removed* method: `void sendAnnotation(String, ArrayList<AnnotationEntity>, String, String)`

*modified* class: `BlackBoxConnection`

|       | Declaration                                                                                |
| ----- | ------------------------------------------------------------------------------------------ |
| From: | public class BlackBoxConnection extends WebSocketListener implements CustomService         |
| To:   | public class BlackBoxConnection extends WebSocketListener implements CollabManagerListener |


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.apryse.com/android/changelogs/version-7/v7-0-4.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
